/*

 todo: set quantities
 todo: tie widget quntities to game variables
 todo: set up timeline
 todo: set up dynamics
 todo: set up dialogs
 todo: release resources?
 todo: allow events to, like, end the game, or whatever
 todo: playsample doesn't seem to work:/
 todo: when pop bars move left, blood spatter
 todo: as population decreases, blot out parts of the city
 todo: as population increases, add new bits in(i guess)

 todo: ALLOW INGAME RESTART
 */
#include <allegro.h>
#include <iostream>
#include <vector>
#include <list>
#include <time.h>
#include <algorithm>
#include "boost/foreach.hpp"
//#include <ApplicationServices/ApplicationServices.h>

using namespace std;

#define foreach BOOST_FOREACH

typedef float num;

FONT* gamefont;

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"
#include "dialoguestructs.hpp"
#include "mapmask.hpp"

BITMAP* bitmaparray[14];
BITMAP* buffer;
BITMAP* titlescreen;
BITMAP* introscreen;

BITMAP* maps[4];
BITMAP* sprites;

#include "printwrap.h"

const int FADEMAX=180;
bool fade;
int fadecounter;
bool overatfade;

bool sceneend;
const int ts=13;
char *statustext="";
bool warover=false;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool prevpressedz=1;
bool showdialogue;
bool showmenu;

vector<string> emergencymessages;

char *nulltext="";

int emergencytimer=0;//used for displaying emergency messages in the statusbar



int px;
int py;
int pdir;
bool pmov;

void talkto(int per)
{
	showdialogue=true;
	//	dialoguevector=getdialoguevector(per);
}

void thinkaboutmenu()
{
	showmenu=true;
}

bool talkmode;
bool thinkmode;
bool spacepressed;
string curstring;

void picktalkstring(int n)//-1 for 'think to self'
{


	switch (n)
	{
		case 3:
			actorconv=PLAYER;
		case 4:
			actorconv=LADY;
			break;
		case 5:
			actorconv=BARTENDER;
			break;
		case 6:
			actorconv=CLUBBER;
			break;
		case 7:
			if (talkedto[LADY]&&talkedto[BARTENDER]&&talkedto[MURDERER])
			{
				if (clearthoughts==0&&sexthoughts==0)
					actorconv=DETECTIVE_AFTER2;
				else
					actorconv=DETECTIVE_AFTER;
			}
			else
			{
				actorconv=DETECTIVE;
			}
			break;
		case 8:
		{

			if (scene>2)
				actorconv=MURDERER;
			else
			{
				if (endingtype==3)
					actorconv=PLAYER;
				else
					actorconv=MURDERER;
			}
		}
			break;
		case 9:
			actorconv=VICTIM;
			break;
	}
	linenumber=0;

	if (!talkedto[actorconv])
	{
		talkedto[actorconv]=true;
		talkmode=true;
	}
	else
	{
		talkmode=false;
		spacepressed=true;
	}

}

void startfade()
{
	fade=true;
	fadecounter=FADEMAX;
}

void progressdialogue()
{
	linenumber++;
	if (linenumber>=script[actorconv].conversation.size())
	{
		talkmode=false;
		if (actorconv==DETECTIVE_AFTER || actorconv==DETECTIVE_AFTER2)
		{
			sceneend=true;
			actorconv=INVALID_ACTOR;
			startfade();
		}
		if (scene==1 && talkedto[CLUBBER] && talkedto[MURDERER] && talkedto[LADY] && talkedto[BARTENDER])
		{
			startfade();
			actorconv=INVALID_ACTOR;
			sceneend=true;
		}
		if (scene==2)
		{
			startfade();
			playsample(1);
			sceneend=true;
		}
	}
}


void progressthoughts()
{
	linenumber++;
	if (!talkedto[MURDERER])
	{
		if (linenumber>=script[actorconv].afterthoughts1.size())
			thinkmode=false;
	}
	else
	{
		if (linenumber>=script[actorconv].afterthoughts2.size())
			thinkmode=false;
	}
}


bool canmove(int px, int py)
{
	if (px<0 || py < 0 || px/tilesize>=8 || py/tilesize>=6)
		return false;
	else
	{
		int n=mask[scene][area][py/tilesize][px/tilesize];
		if (n<=3)
		{
			return n!=1;
		}
		else
		{
			if (px%tilesize==0&&py%tilesize==0)
				picktalkstring(n);
			return 0;
		}
	}
}

void gotoarea(int m)
{
	switch (area)
	{
		case 0:
			area = 1;
			px=2*tilesize;
			py=4*tilesize;
			break;

		case 1:
			if (m==2)
			{
				area=0;
				px=2*tilesize;
				py=tilesize;
			}
			else if (m==3)
			{
				area=2;
				px=4*tilesize;
				py=4*tilesize;
			}
			break;
		case 2:
			area=1;
			px=4*tilesize;
			py=tilesize;
			break;
		case 3:

			break;

	}
}

void checkmove()
{
	if (px%tilesize==0&&py%tilesize==0)
	{
		if (mask[scene][area][py/tilesize][px/tilesize]!=0)
		{
			gotoarea(mask[scene][area][py/tilesize][px/tilesize]);
		}
	}
}

bool canthink()
{
	return (!talkmode&&(actorconv!=INVALID_ACTOR)&&!thoughtabout[actorconv]);
}

int move()
{
	if (thinkmode)
	{
		if (key[KEY_SPACE])
		{
			if (!spacepressed)
			{
				progressthoughts();
				spacepressed=true;
			}
		}
		else
		{
			if (spacepressed)
				spacepressed=false;
		}
	}
	if ((!talkmode)&&(!thinkmode))
	{

		if (key[KEY_T] && canthink())
		{
			thoughtabout[actorconv]=true;
			if (talkedto[MURDERER])
			{
				sexthoughts++;
			}
			else
			{
				clearthoughts++;
			}
			thinkmode=true;
			linenumber=0;
		}

		int dir=pdir;

		if (px%tilesize==0&&py%tilesize==0)
		{
			dir=-1;
		}

		if (px%tilesize==0)//can move up/down
		{
			if (key[KEY_UP]&&!key[KEY_DOWN]&& canmove(px,py-tilesize))
				dir=0;
			else if (key[KEY_DOWN]&&!key[KEY_UP]&& canmove(px,py+tilesize))
				dir=1;
		}
		if (py%tilesize==0)//can move left/right
		{
			if (key[KEY_LEFT]&&!key[KEY_RIGHT] && canmove(px-tilesize,py))
				dir=2;
			else if (key[KEY_RIGHT]&&!key[KEY_LEFT]&& canmove(px+tilesize,py))
				dir=3;
		}

		switch(dir)
		{
			case 0:
				py-=4;
				checkmove();
				break;
			case 1:
				py+=4;
				checkmove();
				break;
			case 2:
				px-=4;
				checkmove();
				break;
			case 3:
				px+=4;
				checkmove();
				break;
			default:
				break;
		}

		if (dir>=0)
			pdir=dir;
	}
	else
	{
		if (key[KEY_SPACE])
		{
			if (!spacepressed)
			{
				progressdialogue();
				spacepressed=true;
			}
		}
		else
		{
			if (spacepressed)
				spacepressed=false;
		}

	}

	return 1;
}


int consequences=0;

struct Preface_Info {
	bool big;
	string text;
	int time;
};



class IntroLoop
{
public:
	static void initialize()
	{
		playmusic(0);
		speed_count=0;
		titletimer=0;
		finishedtitle=false;
	}

	static bool quitcondition()
	{
		return quit||warover||finishedtitle;
	}

	static void logic()
	{
		titletimer++;

		if (titletimer>240)
		{
			finishedtitle=true;
		}
		else if (titletimer>100)
		{
			titletimer=240;
		}

	}

	static void draw()
	{

		blit(introscreen, buffer, 0, 0, 0, 0, 1024, 768);
	}
};

int starttimer;
class TitleLoop
{
private:
	static bool begin;
	static int selected;
	static bool upheld;
	static bool downheld;
	static bool spaceheld;
public:
	static void initialize()
	{
		begin=false;
		selected=0;
		upheld=true;
		downheld=true;
		spaceheld=true;
		starttimer=60;
	}

	static void logic()
	{
		if (starttimer>0)
			starttimer--;

		if (key[KEY_UP])
		{
			if (!upheld)
			{
				selected=(selected+1)%2;
				upheld=true;
			}
		}
		else
			upheld=false;

		if (key[KEY_DOWN])
		{
			if (!downheld)
			{
				selected=(selected+1)%2;
				downheld=true;
			}
		}
		else
			downheld=false;

		if (key[KEY_SPACE])
		{
			if (!spaceheld && starttimer==0)
			{
				begin=true;
			}
		}
		else
			spaceheld=false;

	}

	static bool quitcondition()
	{
		return quit||begin;
	}

	static void draw()
	{
		blit(titlescreen, buffer, 0, 0, 0, 0, 1024, 768);
	}

};

bool TitleLoop::begin=false;
int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;

int xmargin=44;
int ymargin=0;



template<class T>
void loop();


class GameLoop
{
public:
	static void initialize()
	{

		playmusic(1);
		endingtype=-1;
		fade=false;
		overatfade=false;
		sceneend=false;
		scene=0;
		consequences=false;
		warover=false;
		leave=false;
		px=tilesize*2;
		py=tilesize;
		talkmode=true;
		thinkmode=false;
		actorconv=DETECTIVE;
		area=0;
		setdialogue();
		spacepressed=true;
		sexthoughts=0;
		clearthoughts=0;

		for (int i=0;i<8;i++)
			talkedto[i]=0;
		talkedto[DETECTIVE]=true;

	}

	static bool quitcondition()
	{
		return quit||leave||warover;
	}

	static void logic()
	{
		if (fade)
		{
			fadecounter--;
			if (overatfade &&fadecounter<=FADEMAX/2)
				leave=true;

			if (fadecounter<=0)
				fade=false;
			return;
		}
		if (sceneend)
		{
			sceneend=false;
			switch (scene)
			{
				case 0:
				{
					if (clearthoughts==0&&sexthoughts==0)
					{
						overatfade=true;
						endingtype=0;
					}
					else
					{
						for (int i=0;i<12;i++)
						{
							talkedto[i]=0;
							thoughtabout[i]=0;
						}
						scene++;
						clearthoughts=0;
						playmusic(2);
						setdialogue();

						area=2;
						px=4*tilesize;
						py=4*tilesize;
					}
				}
					break;
				case 1:
				{
					if (clearthoughts<3 && sexthoughts<2)
					{
						overatfade=true;
						endingtype=1;
					}
					else if (clearthoughts>=3)
					{//arrest
						overatfade=true;
						endingtype=2;
					}
					else if (sexthoughts==7)
					{//maxed out besotment
						for (int i=0;i<12;i++)
						{
							talkedto[i]=0;
							thoughtabout[i]=0;
						}
						scene++;
						clearthoughts=0;
						playmusic(3);
						area=3;
						px=2*tilesize;
						py=5*tilesize;
						setdialogue();
						endingtype=4;
					}
					else
					{//still go back, but...not a willing victim
						for (int i=0;i<12;i++)
						{
							talkedto[i]=0;
							thoughtabout[i]=0;
						}
						scene++;
						clearthoughts=0;
						area=3;
						playmusic(3);
						px=2*tilesize;
						py=5*tilesize;
						setdialogue();
						endingtype=3;
					}
				}
					break;
				case 2:
				{
					overatfade=true;
				}
					break;

			}

		}
		else
		{
		}
		move();
	}

	static void draw()
	{
		if (fade)
		{
			if (fadecounter>FADEMAX/2)
			{
				for (int i=0;i<20;i++)
				{
					if (rand()%(fadecounter-(FADEMAX/2 - 1)) ==0)
						rectfill(buffer, 0, (i*768)/20, 1023, ((i+1)*768)/20, makecol(0,0,0));
				}
				return;
			}
			else if (fadecounter+1>FADEMAX/2)
			{
				fade=false;
				logic();
				fade=true;
			}
		}

		blit(maps[area],buffer,0,0,0,0,1024,768);
		for (int i=0;i<8;i++)
			for (int j=0;j<6;j++)
			{
				int n=mask[scene][area][j][i];
				if (n>3)
					masked_blit(bitmaparray[n-3],buffer,0,0,i*tilesize+xmargin,j*tilesize+ymargin,tilesize,tilesize);
			}
		masked_blit(bitmaparray[0],buffer,0,0,px+xmargin,py+ymargin,tilesize,tilesize);


            const int xoffset1=280+15;
            const int xoffset2=420;
            const int wrapwidth=29;

			int yoffset=552;

			if (py>300)
				yoffset=91;

            const int dyoffset=yoffset+10;

		if (talkmode)
		{


			rectfill(buffer, 280, yoffset, 780	, yoffset+140, makecol(0,0,0));
			if (script[actorconv].conversation[linenumber].speaker==PLAYER)
			{
				rectfill(buffer, 280+5, yoffset+5, 280+5+120	, yoffset+140-5, makecol(255,255,255));
				masked_blit(bitmaparray[script[actorconv].conversation[linenumber].speaker],buffer,0,0,280+5,yoffset+5,tilesize,tilesize);
    			wrapprint(script[actorconv].conversation[linenumber].line.c_str(), xoffset2, dyoffset, wrapwidth);
			}
			else if (script[actorconv].conversation[linenumber].speaker==GPLAYER)
			{
				rectfill(buffer, 280+5, yoffset+5, 280+5+120	, yoffset+140-5, makecol(255,255,255));
				masked_blit(bitmaparray[PLAYER],buffer,0,0,280+5,yoffset+5,tilesize,tilesize);
                wrapprint(script[actorconv].conversation[linenumber].line.c_str(), xoffset2, dyoffset, wrapwidth);
			}
			else if (script[actorconv].conversation[linenumber].speaker==GMURDERER)
			{
				rectfill(buffer, 780-5-120, yoffset+5, 780-5	, yoffset+140-5, makecol(255,255,255));
                wrapprint(script[actorconv].conversation[linenumber].line.c_str(), xoffset1, dyoffset, wrapwidth);

				static int timer=0;
				timer=(timer+1)%80;
				if ((timer/40) %2==0)
					masked_blit(bitmaparray[MURDERER],buffer,0,0,780-5-120,yoffset+5,tilesize,tilesize);
				else
					masked_blit(bitmaparray[8],buffer,0,0,780-5-120,yoffset+5,tilesize,tilesize);

			}
			else
			{
                wrapprint(script[actorconv].conversation[linenumber].line.c_str(), xoffset1, dyoffset, wrapwidth);
				rectfill(buffer, 780-5-120, yoffset+5, 780-5	, yoffset+140-5, makecol(255,255,255));
				masked_blit(bitmaparray[script[actorconv].conversation[linenumber].speaker],buffer,0,0,780-5-120,yoffset+5,tilesize,tilesize);
			}

		}
		else if (thinkmode)
		{

            rectfill(buffer, 280, yoffset, 780	, yoffset+140, makecol(0,0,0));

			if (!talkedto[MURDERER])
			{
				wrapprint(script[actorconv].afterthoughts1[linenumber].c_str(),  xoffset2, dyoffset, wrapwidth);
			}
			else
			{
				wrapprint(script[actorconv].afterthoughts2[linenumber].c_str(),  xoffset2, dyoffset, wrapwidth);
			}

            rectfill(buffer, 280+5, yoffset+5, 280+5+120	, yoffset+140-5, makecol(255,255,255));
			masked_blit(bitmaparray[PLAYER],buffer,0,0,280+5,yoffset+5,tilesize,tilesize);


		}
		else if (canthink())
		{
			rectfill(buffer,10,10,34,35,makecol(0,0,0));
			textout_ex(buffer, gamefont, "T", 17, 17, makecol(255,255,255), makecol(0,0,0));
		}

		if (fade)
		{
			if (fadecounter<=FADEMAX/2&&fadecounter>0)
			{
				rectfill(buffer,0,0,1023,(767*fadecounter) / (FADEMAX/2),makecol(0,0,0));
			}
		}

	}

};

int looptimer;

class GameOverLoop
{
private:
	static bool done;
	static string message[4];
public:

	static void initialize()
	{

		if (endingtype>=3)//get shot
		{
			//BANG
		}

		done=false;

		looptimer=60;


	}

	static bool quitcondition()
	{
		return warover||quit;
	}

	static void logic()
	{
		if (looptimer>0)
		{
			looptimer--;


			spacepressed=true;
		}
		else if (key[KEY_SPACE])
		{
			if (!spacepressed)
			{
				warover=true;
			}
		}
		else
		{
			spacepressed=false;
		}
	}

	static void draw()
	{

  		clear_to_color(buffer,makecol(0,0,0));

		wrapprint(endingtexts[endingtype], 390, 340, 20);

	}

};

bool GameOverLoop::done=false;
string GameOverLoop::message[4]={};


template<class T>
void loop()
{

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			if (key[KEY_ESC])
				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

		blit(buffer,screen,0,0,0,0,1024,768);

	}
}

void dotransition()
{
}

void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	//	int depth = desktop_color_depth();

	//	if (depth == 0) depth = 32;
	//		set_color_depth(depth);
	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();

	//CGDisplayHideCursor(kCGDirectMainDisplay);

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(60));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0) ;

	//init the buffer
	buffer=create_bitmap(1024,768);

	//load font

    gamefont=load_bitmap_font("bmp/font.pcx",NULL,NULL);

	//button
	BITMAP* spritesheet = load_bitmap("bmp/sprites.bmp", NULL);
	for (int i=0;i<9;i++)
	{
		bitmaparray[i]=create_bitmap(tilesize,tilesize);
		blit(spritesheet,bitmaparray[i],i*tilesize,0,0,0,tilesize,tilesize);
	}

	delete spritesheet;



	introscreen = load_bitmap("bmp/intro.bmp",NULL);
	titlescreen = load_bitmap("bmp/titlescreen.bmp",NULL);


	maps[0]=load_bitmap("bmp/map1.bmp",NULL);
	maps[1]=load_bitmap("bmp/map2.bmp",NULL);
	maps[2]=load_bitmap("bmp/map3.bmp",NULL);
	maps[3]=load_bitmap("bmp/map4.bmp",NULL);

	sprites=load_bitmap("bmp/sprites.bmp",NULL);

	srand(time(0));

}

void drawthinkaboutmenu()
{
	/*
	drawpanel(x,y,blah,blah);
	printtext("think about")
	for (int i=0;i<9;i++)
	{
		blit(entityimage[i],x+tilewidth*(i/3),y+tilewidth*(i%3));
	}
	 */
}

int main(int argc, char *argv[])
{
	init();

	loop<IntroLoop>();


	while (!quit)
	{
		loop<TitleLoop>();

		loop<GameLoop>();

		loop<GameOverLoop>();

		playmusic(0);
	}

	return 0;
}
END_OF_MAIN()
